-- scope stuff
qualityoflife = qualityoflife or {};
local q = qualityoflife;

q.modules = q.modules or {};
q.modules["QoL_ClassicHeals"] = q.modules["QoL_ClassicHeals"] or {};
local c = q.modules["QoL_ClassicHeals"];

local profileFrame;
local fontFlags;
local spellSources, spellSourcesOrder;
local spellTypes, spellTypesOrder;

local frameSamples;

local lblProfile, cbProfile, chIsProfileEnabled;
local cbSubProfile, chIsSubProfileEnabled;
local cbSpellType, chIsSpellTypeEnabled;
local cbSpellSource, chIsSpellSourceEnabled;

local lblXOffset, sldXOffset;
local lblYOffset, sldYOffset;
local lblFontSize, sldFontSize;
local lblFontSizeCritical, sldFontSizeCritical;
local lblFontFlags, cbFontFlags;

local lblOverheal, chShowOverheal, chShowFull, chShowZero;

local lblFontColor, lblFontColorSample, lblFontColorCritical, lblFontColorCriticalSample, lblFontColorOverheal, lblFontColorOverhealSample;
local lblFontColorR, sldFontColorR, sldFontColorCriticalR, sldFontColorOverhealR;
local lblFontColorG, sldFontColorG, sldFontColorCriticalG, sldFontColorOverhealG;
local lblFontColorB, sldFontColorB, sldFontColorCriticalB, sldFontColorOverhealB;
local lblFontColorA, sldFontColorA, sldFontColorCriticalA, sldFontColorOverhealA;

local btnReset, btnResetAll;

local spacings, spacingIndex = {};
local labelWidth, sliderWidth = 180, 170;
local sldFontColorXOffset, sldFontColorCriticalXOffset, sldFontColorOverhealXOffset = 55, 240, 425;

function c:InitOptions()
	c.OPT_VISITED = "OPT_VISITED";

	-- attributes
	c.OPT_UIATTR_ENABLED = "OPT_UIATTR_ENABLED";
	c.OPT_UIATTR_FONTSIZE = "OPT_UIATTR_FONTSIZE";
	c.OPT_UIATTR_FONTSIZE_CRITICAL = "OPT_UIATTR_FONTSIZE_CRITICAL";
	c.OPT_UIATTR_FONTCOLOR = "OPT_UIATTR_FONTCOLOR";
	c.OPT_UIATTR_FONTFLAGS = "OPT_UIATTR_FONTFLAGS";
	c.OPT_UIATTR_FONTCOLOR_CRITICAL = "OPT_UIATTR_FONTCOLOR_CRITICAL";
	c.OPT_UIATTR_FONTCOLOR_OVERHEAL = "OPT_UIATTR_FONTCOLOR_OVERHEAL";
	c.OPT_UIATTR_XOFFSET = "OPT_UIATTR_XOFFSET";
	c.OPT_UIATTR_YOFFSET = "OPT_UIATTR_YOFFSET";

	c.OPT_UIATTR_SHOWOVERHEAL = "OPT_SHOWOVERHEAL";
	c.OPT_UIATTR_SHOWFULL = "OPT_SHOWFULL";

	c.OPT_UIATTR_SHOWZERO = "OPT_UIATTR_SHOWZERO";
	c.OPT_UIATTR_SHOWZEROASOVERHEAL = "OPT_UIATTR_SHOWZEROASOVERHEAL";

	c.OPT_UI_LASTPROFILE = "OPT_UI_LASTPROFILE";

	if not c:GetProfile(QOL_OPTIONS[c.name][c.OPT_UI_LASTPROFILE]) then
		QOL_OPTIONS[c.name][c.OPT_UI_LASTPROFILE] = c.PROFILE_DEFAULT;
	end

	if not fontFlags then
		fontFlags = {};
		table.insert(fontFlags, "");
		table.insert(fontFlags, "OUTLINE");
		table.insert(fontFlags, "THICKOUTLINE");
		table.insert(fontFlags, "MONOCHROME");
		table.insert(fontFlags, "OUTLINE, MONOCHROME");
		table.insert(fontFlags, "THICKOUTLINE, MONOCHROME");
	end

	if not spellSources then
		spellSources, spellSourcesOrder = {
			[c.SPELLSOURCE_SELF] = q:GetText("Own Heals"),
			[c.SPELLSOURCE_OTHERS] = q:GetText("Others Heals"),
		}, {};
		table.insert(spellSourcesOrder, c.SPELLSOURCE_SELF);
		table.insert(spellSourcesOrder, c.SPELLSOURCE_OTHERS);
	end

	if not spellTypes then
		spellTypes, spellTypesOrder = {
			[c.SPELL_HEAL] = q:GetText("Direct Heals"),
			[c.SPELL_PERIODIC_HEAL] = q:GetText("Heals Over Time (HOTs)")
		}, {};
		table.insert(spellTypesOrder, c.SPELL_HEAL);
		table.insert(spellTypesOrder, c.SPELL_PERIODIC_HEAL);
	end

	-- optionsPanel init
	if not c.optionsPanel then
		c.optionsPanel = CreateFrame("Frame", "QoLOptionsFrame_ClassicHeals", q.optionsPanel);
		c.optionsPanel.name = "ClassicHeals";
		c.optionsPanel.parent = q.optionsPanel.name;
		c.optionsPanel.cancel = function(self) c:RevertSettingsChanges(); end;
		InterfaceOptions_AddCategory(c.optionsPanel);
		c.optionsPanel:SetScript("OnShow", function()
			if c.initFinished then
				c:ShowOptionsPanel();
				QOL_OPTIONS[c.name][c.OPT_VISITED] = true;
				c.optionsPanel.oldValues[c.OPT_VISITED] = true;
			end
		end);
		q:HandleElvUi(c.optionsPanel);

		-- workaround for lazy profile loading (addon loading timing problem)
		_G["InterfaceOptionsFrameTab2"]:HookScript("OnClick", function()
			c:InitProfiles(true);
			c:ShowOptionsPanel();
		end);

		c:ShowOptionsPanel();
	end

	--q:HookOptionsSparks(c);
	return true;
end

function c:ShowOptionsPanel()
	spacingIndex, c.optionsPanel.oldValues = 1, q:Deepcopy(QOL_OPTIONS[c.name]);

	-- profile
	if not lblProfile then
		lblProfile = q:CreateOptionsLabel(c.optionsPanel, q:GetText("Profile:"), nil, true);
	end

	--if not frameSamples then -- experimental
	--	frameSamples = CreateFrame("Frame", "QoLOptionElement_testFrame", c.optionsPanel);
	--	frameSamples:SetHeight(40);
	--	frameSamples:SetWidth(80);
	--	frameSamples:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",
	--							edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	--							tile = true, tileSize = 16, edgeSize = 4,
	--							insets = { left = 1, right = 1, top = 1, bottom = 1 }});
	--	frameSamples:SetBackdropColor(0, 1, 0, 1);
	--	frameSamples:SetPoint("TOPLEFT", 60, -60);

	--	frameSamples.namePlate = frameSamples:CreateFontString("QoLOptionElement_testFrame_FontString", "ARTWORK");
	--	frameSamples.namePlate:SetFontObject(SystemFont_NamePlate);
	--	frameSamples.namePlate:SetPoint("TOP", 0, -3);
	--	frameSamples.namePlate:SetText("CharacterName");

	--	frameSamples.sampleHeal = frameSamples:CreateFontString("QoLOptionElement_testFrame_FontString", "ARTWORK");
	--	frameSamples.sampleHeal:SetFontObject(SystemFont_NamePlate);
	--	frameSamples.sampleHeal:SetPoint("TOP", 0, -3);
	--	frameSamples.sampleHeal:SetText("CharacterName");

	--	frameSamples:Show();
	--end

	if not chIsProfileEnabled then
		chIsProfileEnabled = q:CreateOptionsCheckbox(c.optionsPanel, q:GetText("Enabled"), function(self)
			c:chIsProfileEnabled_SetValue(self:GetChecked());
		end, 365, true);
	end

	if not cbProfile then
		cbProfile = q:CreateOptionsDropdown(c.optionsPanel, function(self, level, menuList)
			local info = UIDropDownMenu_CreateInfo();
			info.hasArrow = false;
			info.notCheckable  = true;
			info.func = function(self)
				c:cbProfile_SetValue(self.value);
				CloseDropDownMenus();
			end;

			if c.initFinished and (level or 1) == 1 then
				for index, profileEntry in ipairs(c:GetProfiles()) do
					info.text = c:GetProfileDescription(profileEntry[c.PROFILEKEY_KEY]);
					info.value = profileEntry;
					UIDropDownMenu_AddButton(info);
				end
			end
		end, labelWidth);
	end

	-- sub profile
	if not chIsSubProfileEnabled then
		chIsSubProfileEnabled = q:CreateOptionsCheckbox(c.optionsPanel, q:GetText("Enabled"), function(self)
			if c.initFinished then
				c:chIsSubProfileEnabled_SetValue(self:GetChecked());
			end
		end, 365, true);
	end

	if not cbSubProfile then
		cbSubProfile = q:CreateOptionsDropdown(c.optionsPanel, function(self, level, menuList)
			local info = UIDropDownMenu_CreateInfo();
			info.hasArrow = false;
			info.notCheckable  = true;
			info.func = function(self)
				c:cbSubProfile_SetValue(self.value);
				CloseDropDownMenus();
			end;

			if c.initFinished and (level or 1) == 1 then
				local subProfiles = cbProfile.value[c.PROFILEKEY_SUBPROFILES];
				if subProfiles then
					for index, profileKey in ipairs(subProfiles) do
						info.text = c:GetProfileDescription(profileKey);
						info.value = profileKey;
						UIDropDownMenu_AddButton(info);
					end
				end
			end
		end, labelWidth);
	end

	-- spell type
	if not chIsSpellTypeEnabled then
		chIsSpellTypeEnabled = q:CreateOptionsCheckbox(c.optionsPanel, q:GetText("Enabled"), function(self)
			if c.initFinished then
				c:chIsSpellTypeEnabled_SetValue(self:GetChecked());
			end
		end, 365, true);
	end

	if not cbSpellType then
		cbSpellType = q:CreateOptionsDropdown(c.optionsPanel, function(self, level, menuList)
			local info = UIDropDownMenu_CreateInfo();
			info.hasArrow = false;
			info.notCheckable  = true;
			info.func = function(self)
				c:cbSpellType_SetValue(self.value);
				CloseDropDownMenus();
			end;

			if c.initFinished and (level or 1) == 1 then
				for index, spellType in ipairs(spellTypesOrder) do
					info.text = spellTypes[spellType];
					info.value = spellType;
					UIDropDownMenu_AddButton(info);
				end
			end
		end, labelWidth);
	end

	-- spell source
	if not chIsSpellSourceEnabled then
		chIsSpellSourceEnabled = q:CreateOptionsCheckbox(c.optionsPanel, q:GetText("Enabled"), function(self)
			if c.initFinished then
				QOL_OPTIONS[c.name][cbProfile.value[c.PROFILEKEY_KEY]][cbSubProfile.value][cbSpellType.value][cbSpellSource.value][c.OPT_UIATTR_ENABLED] = self:GetChecked();
				c:SetProfileValues();
			end
		end, 365, true);
	end

	if not cbSpellSource then
		cbSpellSource = q:CreateOptionsDropdown(c.optionsPanel, function(self, level, menuList)
			local info = UIDropDownMenu_CreateInfo();
			info.hasArrow = false;
			info.notCheckable  = true;
			info.func = function(self)
				c:cbSpellSource_SetValue(self.value);
				CloseDropDownMenus();
			end;

			if c.initFinished and (level or 1) == 1 then
				for index, spellSource in ipairs(spellSourcesOrder) do
					info.text = spellSources[spellSource];
					info.value = spellSource;
					UIDropDownMenu_AddButton(info);
				end
			end
		end, labelWidth);
	end

	if table.getn(c:GetProfiles(true)) < 2 then
		UIDropDownMenu_DisableDropDown(cbProfile);
	else
		UIDropDownMenu_EnableDropDown(cbProfile);
	end

	local lastProfileKey = QOL_OPTIONS[c.name][c.OPT_UI_LASTPROFILE];
	cbProfile:SetText(c:GetProfileDescription(lastProfileKey));
	cbProfile.value = c:GetProfile(lastProfileKey);
	chIsProfileEnabled:SetChecked(QOL_OPTIONS[c.name][lastProfileKey][c.OPT_UIATTR_ENABLED]);

	if QOL_OPTIONS[c.name][lastProfileKey][c.OPT_UIATTR_ENABLED] then
		cbSubProfile:Show();
		chIsSubProfileEnabled:Show();
	else
		cbSubProfile:Hide();
		chIsSubProfileEnabled:Hide();
	end

	local lastSubProfileKey = QOL_OPTIONS[c.name][lastProfileKey][c.OPT_UI_LASTPROFILE];
	cbSubProfile:SetText(c:GetProfileDescription(lastSubProfileKey));
	cbSubProfile.value = lastSubProfileKey;
	chIsSubProfileEnabled:SetChecked(QOL_OPTIONS[c.name][lastProfileKey][lastSubProfileKey][c.OPT_UIATTR_ENABLED]);

	local lastSpellTypeKey = QOL_OPTIONS[c.name][lastProfileKey][lastSubProfileKey][c.OPT_UI_LASTPROFILE];
	cbSpellType:SetText(spellTypes[lastSpellTypeKey]);
	cbSpellType.value = lastSpellTypeKey;
	chIsSpellTypeEnabled:SetChecked(QOL_OPTIONS[c.name][lastProfileKey][lastSubProfileKey][lastSpellTypeKey][c.OPT_UIATTR_ENABLED]);

	local lastSpellSourceKey = QOL_OPTIONS[c.name][lastProfileKey][lastSubProfileKey][lastSpellTypeKey][c.OPT_UI_LASTPROFILE];
	cbSpellSource:SetText(spellSources[lastSpellSourceKey]);
	cbSpellSource.value = lastSpellSourceKey;
	chIsSpellSourceEnabled:SetChecked(QOL_OPTIONS[c.name][lastProfileKey][lastSubProfileKey][lastSpellTypeKey][lastSpellSourceKey][c.OPT_UIATTR_ENABLED]);

	-- profile frame
	if not profileFrame then
		profileFrame = q:CreateOptionsChildFrame(c.optionsPanel, 0);
	end

	-- xOffset
	if not lblXOffset then
		lblXOffset = q:CreateOptionsLabel(profileFrame, nil, 0, true);
	end
	if not sldXOffset then
		sldXOffset = q:CreateOptionsSlider(profileFrame, -75, 75, function(self) c:SldXOffset_ValueChanged(self) end, labelWidth, false, sliderWidth, 1, q:GetText("left"), q:GetText("right"));
	end

	-- yOffset
	if not lblYOffset then
		lblYOffset = q:CreateOptionsLabel(profileFrame, nil, 0, true);
	end
	if not sldYOffset then
		sldYOffset = q:CreateOptionsSlider(profileFrame, -75, 75, function(self) c:SldYOffset_ValueChanged(self) end, labelWidth, true, sliderWidth, 1, q:GetText("lower"), q:GetText("higher"));
	end

	if not lblOverheal then
		lblOverheal = q:CreateOptionsLabel(profileFrame, q:GetText("When target is fully healed:"), sldFontColorOverhealXOffset);
	end

	c:InsertSpacing();

	-- fontsize
	if not lblFontSize then
		lblFontSize = q:CreateOptionsLabel(profileFrame, nil, 0, true);
	end
	if not sldFontSize then
		sldFontSize = q:CreateOptionsSlider(profileFrame, 10, 30, function(self) c:SldFontSize_ValueChanged(self) end, labelWidth, true, sliderWidth);
	end

	-- show +0
	if not chShowZero then
		chShowZero = q:CreateOptionsCheckbox(profileFrame, q:GetText("Show +0"), function(self)
			c:GetCurrentProfile()[c.OPT_UIATTR_SHOWZERO] = self:GetChecked();
			if self:GetChecked() then
				c:GetCurrentProfile()[c.OPT_UIATTR_SHOWFULL] = false;
				chShowFull:SetChecked(false);

				c:GetCurrentProfile()[c.OPT_UIATTR_SHOWOVERHEAL] = false;
				chShowOverheal:SetChecked(false);
			end
			c:ToggleOverhealDisplay();
		end, sldFontColorOverhealXOffset + 5);
	end

	-- fontsize (critical)
	if not lblFontSizeCritical then
		lblFontSizeCritical = q:CreateOptionsLabel(profileFrame, nil, 0, true);
	end
	if not sldFontSizeCritical then
		sldFontSizeCritical = q:CreateOptionsSlider(profileFrame, 10, 30, function(self) c:SldFontSizeCritical_ValueChanged(self) end, labelWidth, true, sliderWidth);
	end

	-- show "full"
	if not chShowFull then
		chShowFull = q:CreateOptionsCheckbox(profileFrame, q:GetText("Show \"full\""), function(self)
			c:GetCurrentProfile()[c.OPT_UIATTR_SHOWFULL] = self:GetChecked();
			if self:GetChecked() then
				c:GetCurrentProfile()[c.OPT_UIATTR_SHOWZERO] = false;
				chShowZero:SetChecked(false);

				c:GetCurrentProfile()[c.OPT_UIATTR_SHOWOVERHEAL] = false;
				chShowOverheal:SetChecked(false);
			end
			c:ToggleOverhealDisplay();
		end, sldFontColorOverhealXOffset + 5);
	end

	-- font flags
	if not lblFontFlags then
		lblFontFlags = q:CreateOptionsLabel(profileFrame, q:GetText("Font Flags"), 0, true);
	end
	if not cbFontFlags then
		cbFontFlags = q:CreateOptionsDropdown(profileFrame, function(self, level, menuList)
			local info = UIDropDownMenu_CreateInfo();
			info.hasArrow = false;
			info.notCheckable  = true;
			info.func = function(self)
				c:cbFontFlags_SetValue(self.value);
				CloseDropDownMenus();
			end;

			if (level or 1) == 1 then
				for index, fontFlag in ipairs(fontFlags) do
					info.text = fontFlag;
					info.value = fontFlag;
					UIDropDownMenu_AddButton(info);
				end
			end
		end, labelWidth, nil, true);
	end

	-- show overheal
	if not chShowOverheal then
		chShowOverheal = q:CreateOptionsCheckbox(profileFrame, q:GetText("Show overheal"), function(self)
			c:GetCurrentProfile()[c.OPT_UIATTR_SHOWOVERHEAL] = self:GetChecked();
			if self:GetChecked() then
				c:GetCurrentProfile()[c.OPT_UIATTR_SHOWFULL] = false;
				chShowFull:SetChecked(false);

				c:GetCurrentProfile()[c.OPT_UIATTR_SHOWZERO] = false;
				chShowZero:SetChecked(false);
			end
			c:ToggleOverhealDisplay();
		end, sldFontColorOverhealXOffset + 5);
	end

	c:InsertSpacing();

	-- fontcolor
	if not lblFontColor then
		lblFontColor = q:CreateOptionsLabel(profileFrame, q:GetText("Font Color:"), sldFontColorXOffset, true);
	end
	if not lblFontColorSample then
		lblFontColorSample = q:CreateOptionsLabel(profileFrame, q:GetText("+1112"), labelWidth, true);
	end
	if not lblFontColorCritical then
		lblFontColorCritical = q:CreateOptionsLabel(profileFrame, q:GetText("Font Color (critical):"), sldFontColorCriticalXOffset, true);
	end
	if not lblFontColorCriticalSample then
		lblFontColorCriticalSample = q:CreateOptionsLabel(profileFrame, q:GetText("+1112"), 365, true);
	end
	if not lblFontColorOverheal then
		lblFontColorOverheal = q:CreateOptionsLabel(profileFrame, nil, sldFontColorOverhealXOffset, true);
	end
	if not lblFontColorOverhealSample then
		lblFontColorOverhealSample = q:CreateOptionsLabel(profileFrame, nil, 550);
	end

	if not lblFontColorR then
		lblFontColorR = q:CreateOptionsLabel(profileFrame, q:GetText("Red"), 0, true);
	end
	if not sldFontColorR then
		sldFontColorR = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorXOffset, true, nil, 0.01);
		sldFontColorR.profile, sldFontColorR.col = c.OPT_UIATTR_FONTCOLOR, "r";
	end
	if not sldFontColorCriticalR then
		sldFontColorCriticalR = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorCriticalXOffset, true, nil, 0.01);
		sldFontColorCriticalR.profile, sldFontColorCriticalR.col = c.OPT_UIATTR_FONTCOLOR_CRITICAL, "r";
	end
	if not sldFontColorOverhealR then
		sldFontColorOverhealR = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorOverhealXOffset, false, nil, 0.01);
		sldFontColorOverhealR.profile, sldFontColorOverhealR.col = c.OPT_UIATTR_FONTCOLOR_OVERHEAL, "r";
	end

	if not lblFontColorG then
		lblFontColorG = q:CreateOptionsLabel(profileFrame, q:GetText("Green"), 0, true);
	end
	if not sldFontColorG then
		sldFontColorG = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorXOffset, true, nil, 0.01);
		sldFontColorG.profile, sldFontColorG.col = c.OPT_UIATTR_FONTCOLOR, "g";
	end
	if not sldFontColorCriticalG then
		sldFontColorCriticalG = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorCriticalXOffset, true, nil, 0.01);
		sldFontColorCriticalG.profile, sldFontColorCriticalG.col = c.OPT_UIATTR_FONTCOLOR_CRITICAL, "g";
	end
	if not sldFontColorOverhealG then
		sldFontColorOverhealG = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorOverhealXOffset, false, nil, 0.01);
		sldFontColorOverhealG.profile, sldFontColorOverhealG.col = c.OPT_UIATTR_FONTCOLOR_OVERHEAL, "g";
	end

	if not lblFontColorB then
		lblFontColorB = q:CreateOptionsLabel(profileFrame, q:GetText("Blue"), 0, true);
	end
	if not sldFontColorB then
		sldFontColorB = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorXOffset, true, nil, 0.01);
		sldFontColorB.profile, sldFontColorB.col = c.OPT_UIATTR_FONTCOLOR, "b";
	end
	if not sldFontColorCriticalB then
		sldFontColorCriticalB = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorCriticalXOffset, true, nil, 0.01);
		sldFontColorCriticalB.profile, sldFontColorCriticalB.col = c.OPT_UIATTR_FONTCOLOR_CRITICAL, "b";
	end
	if not sldFontColorOverhealB then
		sldFontColorOverhealB = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorOverhealXOffset, false, nil, 0.01);
		sldFontColorOverhealB.profile, sldFontColorOverhealB.col = c.OPT_UIATTR_FONTCOLOR_OVERHEAL, "b";
	end

	if not lblFontColorA then
		lblFontColorA = q:CreateOptionsLabel(profileFrame, q:GetText("Alpha"), 0, true);
	end
	if not sldFontColorA then
		sldFontColorA = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorXOffset, true, nil, 0.01);
		sldFontColorA.profile, sldFontColorA.col = c.OPT_UIATTR_FONTCOLOR, "a";
	end
	if not sldFontColorCriticalA then
		sldFontColorCriticalA = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorCriticalXOffset, false, nil, 0.01);
		sldFontColorCriticalA.profile, sldFontColorCriticalA.col = c.OPT_UIATTR_FONTCOLOR_CRITICAL, "a";
	end

	c:InsertSpacing();

	-- reset
	if not btnReset then
		btnReset = q:CreateOptionsButton(profileFrame, q:GetText("Reset"), function()
			local profileKey = cbProfile.value[c.PROFILEKEY_KEY];
			local subProfileKey = cbSubProfile.value;
			local spellType = cbSpellType.value;
			local spellSource = cbSpellSource.value;
	
			if spellSource and chIsSpellTypeEnabled:GetChecked() then
				QOL_OPTIONS[c.name][profileKey][subProfileKey][spellType][spellSource] = {};
				QOL_OPTIONS[c.name][profileKey][subProfileKey][spellType][spellSource][c.OPT_UIATTR_ENABLED] = true;
			elseif spellType and chIsSubProfileEnabled:GetChecked() then
				QOL_OPTIONS[c.name][profileKey][subProfileKey][spellType] = {};
				QOL_OPTIONS[c.name][profileKey][subProfileKey][spellType][c.OPT_UIATTR_ENABLED] = true;
			elseif subProfileKey and chIsProfileEnabled:GetChecked() then
				QOL_OPTIONS[c.name][profileKey][subProfileKey] = {};
				QOL_OPTIONS[c.name][profileKey][subProfileKey][c.OPT_UIATTR_ENABLED] = true;
			else
				QOL_OPTIONS[c.name][profileKey] = {};
				QOL_OPTIONS[c.name][profileKey][c.OPT_UIATTR_ENABLED] = true;
			end

			c:InitProfiles(true);
			c:InitOptions();
			c:SetProfileValues();
		end);
	end

	c:InsertSpacing();

	-- reset all
	if not btnResetAll then
		btnResetAll = q:CreateOptionsButton(c.optionsPanel, q:GetText("Reset all"), function()
			c:ShowResetDialog();
		end);
		btnResetAll:ClearAllPoints();
		btnResetAll:SetPoint("BOTTOMLEFT", 15, 15);
	end

	C_Timer.After(0.25, function()
		c:SetProfileValues();
	end);
end

function c:InsertSpacing()
	if not spacings[spacingIndex] then
		spacings[spacingIndex] = q:CreateOptionsSpacing(profileFrame);
	end
	spacingIndex = spacingIndex + 1;
end

function c:cbProfile_SetValue(value)
	local profileKey = value[c.PROFILEKEY_KEY];

	cbProfile.value = value;
	cbProfile:SetText(c:GetProfileDescription(profileKey));
	chIsProfileEnabled:SetChecked(QOL_OPTIONS[c.name][profileKey][c.OPT_UIATTR_ENABLED]);

	if c.initFinished then
		if QOL_OPTIONS[c.name][profileKey][c.OPT_UIATTR_ENABLED] and value[c.PROFILEKEY_SUBPROFILES] then
			cbSubProfile:Show();
			chIsSubProfileEnabled:Show();

			if table.getn(value[c.PROFILEKEY_SUBPROFILES]) < 2 then
				UIDropDownMenu_DisableDropDown(cbSubProfile);
			else
				UIDropDownMenu_EnableDropDown(cbSubProfile);
			end
			c:cbSubProfile_SetValue(QOL_OPTIONS[c.name][profileKey][c.OPT_UI_LASTPROFILE]);
		else
			cbSubProfile:Hide();
			chIsSubProfileEnabled:Hide();
			cbSpellType:Hide();
			chIsSpellTypeEnabled:Hide();
			cbSpellSource:Hide();
			chIsSpellSourceEnabled:Hide();
			c:SetProfileValues();
		end
		QOL_OPTIONS[c.name][c.OPT_UI_LASTPROFILE] = profileKey;
	end
end

function c:chIsProfileEnabled_SetValue(value)
	if c.initFinished then
		local profileKey = cbProfile.value[c.PROFILEKEY_KEY];
		local subProfileKey = cbSubProfile.value;
		local spellType = cbSpellType.value;

		QOL_OPTIONS[c.name][profileKey][c.OPT_UIATTR_ENABLED] = value;
		if value then
			cbSubProfile:Show();
			chIsSubProfileEnabled:Show();
			if QOL_OPTIONS[c.name][profileKey][subProfileKey][c.OPT_UIATTR_ENABLED] then
				cbSpellType:Show();
				chIsSpellTypeEnabled:Show();
				if QOL_OPTIONS[c.name][profileKey][subProfileKey][spellType][c.OPT_UIATTR_ENABLED] then
					cbSpellSource:Show();
					chIsSpellSourceEnabled:Show();
				end
			end
		else
			cbSubProfile:Hide();
			chIsSubProfileEnabled:Hide();
			cbSpellType:Hide();
			chIsSpellTypeEnabled:Hide();
			cbSpellSource:Hide();
			chIsSpellSourceEnabled:Hide();
		end
		c:SetProfileValues();
	end
end

function c:cbSubProfile_SetValue(subProfileKey)
	local profileKey = cbProfile.value[c.PROFILEKEY_KEY];

	cbSubProfile.value = subProfileKey;
	cbSubProfile:SetText(c:GetProfileDescription(subProfileKey));
	chIsSubProfileEnabled:SetChecked(QOL_OPTIONS[c.name][profileKey][subProfileKey][c.OPT_UIATTR_ENABLED]);

	if c.initFinished then
		if QOL_OPTIONS[c.name][profileKey][subProfileKey][c.OPT_UIATTR_ENABLED] then
			cbSpellType:Show();
			chIsSpellTypeEnabled:Show();
			c:cbSpellType_SetValue(QOL_OPTIONS[c.name][profileKey][subProfileKey][c.OPT_UI_LASTPROFILE]);
		else
			cbSpellType:Hide();
			chIsSpellTypeEnabled:Hide();
			cbSpellSource:Hide();
			chIsSpellSourceEnabled:Hide();
			c:SetProfileValues();
		end
		QOL_OPTIONS[c.name][profileKey][c.OPT_UI_LASTPROFILE] = subProfileKey;
	end
end

function c:chIsSubProfileEnabled_SetValue(value)
	if c.initFinished then
		local profileKey = cbProfile.value[c.PROFILEKEY_KEY];
		local subProfileKey = cbSubProfile.value;
		local spellType = cbSpellType.value;

		QOL_OPTIONS[c.name][profileKey][subProfileKey][c.OPT_UIATTR_ENABLED] = value;
		if value then
			cbSpellType:Show();
			chIsSpellTypeEnabled:Show();
			if QOL_OPTIONS[c.name][profileKey][subProfileKey][spellType][c.OPT_UIATTR_ENABLED] then
				cbSpellSource:Show();
				chIsSpellSourceEnabled:Show();
			end
		else
			cbSpellType:Hide();
			chIsSpellTypeEnabled:Hide();
			cbSpellSource:Hide();
			chIsSpellSourceEnabled:Hide();
		end
		c:SetProfileValues();
	end
end

function c:cbSpellType_SetValue(spellType)
	local profileKey = cbProfile.value[c.PROFILEKEY_KEY];
	local subProfileKey = cbSubProfile.value;

	cbSpellType.value = spellType;
	cbSpellType:SetText(spellTypes[spellType]);
	chIsSpellTypeEnabled:SetChecked(QOL_OPTIONS[c.name][profileKey][subProfileKey][spellType][c.OPT_UIATTR_ENABLED]);

	if c.initFinished then
		if QOL_OPTIONS[c.name][profileKey][subProfileKey][spellType][c.OPT_UIATTR_ENABLED] then
			cbSpellSource:Show();
			chIsSpellSourceEnabled:Show();
			c:cbSpellSource_SetValue(QOL_OPTIONS[c.name][profileKey][subProfileKey][spellType][c.OPT_UI_LASTPROFILE]);
		else
			cbSpellSource:Hide();
			chIsSpellSourceEnabled:Hide();
			c:SetProfileValues();
		end
		QOL_OPTIONS[c.name][profileKey][subProfileKey][c.OPT_UI_LASTPROFILE] = spellType;
	end
end

function c:chIsSpellTypeEnabled_SetValue(value)
	if c.initFinished then
		local profileKey = cbProfile.value[c.PROFILEKEY_KEY];
		local subProfileKey = cbSubProfile.value;
		local spellType = cbSpellType.value;

		QOL_OPTIONS[c.name][profileKey][subProfileKey][spellType][c.OPT_UIATTR_ENABLED] = value;
		if value then
			cbSpellSource:Show();
			chIsSpellSourceEnabled:Show();
		else
			cbSpellSource:Hide();
			chIsSpellSourceEnabled:Hide();
		end
		c:SetProfileValues();
	end
end

function c:cbSpellSource_SetValue(spellSource)
	local profileKey = cbProfile.value[c.PROFILEKEY_KEY];
	local subProfileKey = cbSubProfile.value;
	local spellType = cbSpellType.value;

	cbSpellSource.value = spellSource;
	cbSpellSource:SetText(spellSources[spellSource]);
	chIsSpellSourceEnabled:SetChecked(QOL_OPTIONS[c.name][profileKey][subProfileKey][spellType][spellSource][c.OPT_UIATTR_ENABLED]);

	if c.initFinished then
		QOL_OPTIONS[c.name][profileKey][subProfileKey][spellType][c.OPT_UI_LASTPROFILE] = spellSource;
		c:SetProfileValues();
	end
end

function c:cbFontFlags_SetValue(value)
	cbFontFlags:SetText(value);

	if c.initFinished then
		c:GetCurrentProfile()[c.OPT_UIATTR_FONTFLAGS] = value;
	end
end

function c:SetProfileValues()
	local profileValues = c:GetCurrentProfile();
	local profileKey, subProfileKey, spellType, spellSource = cbProfile.value[c.PROFILEKEY_KEY], cbSubProfile.value, cbSpellType.value, cbSpellSource.value;
	if profileValues and
		QOL_OPTIONS[c.name][profileKey][c.OPT_UIATTR_ENABLED] and
		QOL_OPTIONS[c.name][profileKey][subProfileKey][c.OPT_UIATTR_ENABLED] and
		QOL_OPTIONS[c.name][profileKey][subProfileKey][spellType][c.OPT_UIATTR_ENABLED] and
		QOL_OPTIONS[c.name][profileKey][subProfileKey][spellType][spellSource][c.OPT_UIATTR_ENABLED] then
		profileFrame:Show();

		lblXOffset:SetText(q:GetText("X Offset: %s px", profileValues[c.OPT_UIATTR_XOFFSET]));
		sldXOffset:SetValue(profileValues[c.OPT_UIATTR_XOFFSET]);
		lblYOffset:SetText(q:GetText("Y Offset: %s px", profileValues[c.OPT_UIATTR_YOFFSET]));
		sldYOffset:SetValue(profileValues[c.OPT_UIATTR_YOFFSET]);

		lblFontSize:SetText(q:GetText("Font Size: %s px", profileValues[c.OPT_UIATTR_FONTSIZE]));
		sldFontSize:SetValue(profileValues[c.OPT_UIATTR_FONTSIZE]);
		sldFontSizeCritical:SetValue(profileValues[c.OPT_UIATTR_FONTSIZE_CRITICAL]);
		lblFontSizeCritical:SetText(q:GetText("Font Size (critical): %s px", profileValues[c.OPT_UIATTR_FONTSIZE_CRITICAL]));

		c:cbFontFlags_SetValue(profileValues[c.OPT_UIATTR_FONTFLAGS])

		lblFontColorSample:SetTextColor(q:GetColorRBGA(profileValues[c.OPT_UIATTR_FONTCOLOR]));
		sldFontColorR:SetValue(profileValues[c.OPT_UIATTR_FONTCOLOR]["r"]);
		sldFontColorG:SetValue(profileValues[c.OPT_UIATTR_FONTCOLOR]["g"]);
		sldFontColorB:SetValue(profileValues[c.OPT_UIATTR_FONTCOLOR]["b"]);
		sldFontColorA:SetValue(profileValues[c.OPT_UIATTR_FONTCOLOR]["a"]);

		lblFontColorCriticalSample:SetTextColor(q:GetColorRBGA(profileValues[c.OPT_UIATTR_FONTCOLOR_CRITICAL]));
		sldFontColorCriticalR:SetValue(profileValues[c.OPT_UIATTR_FONTCOLOR_CRITICAL]["r"]);
		sldFontColorCriticalG:SetValue(profileValues[c.OPT_UIATTR_FONTCOLOR_CRITICAL]["g"]);
		sldFontColorCriticalB:SetValue(profileValues[c.OPT_UIATTR_FONTCOLOR_CRITICAL]["b"]);
		sldFontColorCriticalA:SetValue(profileValues[c.OPT_UIATTR_FONTCOLOR_CRITICAL]["a"]);

		lblFontColorOverhealSample:SetTextColor(q:GetColorRBGA(profileValues[c.OPT_UIATTR_FONTCOLOR_OVERHEAL]));
		sldFontColorOverhealR:SetValue(profileValues[c.OPT_UIATTR_FONTCOLOR_OVERHEAL]["r"]);
		sldFontColorOverhealG:SetValue(profileValues[c.OPT_UIATTR_FONTCOLOR_OVERHEAL]["g"]);
		sldFontColorOverhealB:SetValue(profileValues[c.OPT_UIATTR_FONTCOLOR_OVERHEAL]["b"]);

		chShowZero:SetChecked(profileValues[c.OPT_UIATTR_SHOWZERO]);
		chShowOverheal:SetChecked(profileValues[c.OPT_UIATTR_SHOWOVERHEAL]);
		chShowFull:SetChecked(profileValues[c.OPT_UIATTR_SHOWFULL]);

		c:ToggleOverhealDisplay();
	else
		profileFrame:Hide();
	end
end

function c:ToggleOverhealDisplay()
	if chShowOverheal:GetChecked() or chShowZero:GetChecked() or chShowFull:GetChecked() then
		lblFontColorOverheal:Show();
		lblFontColorOverhealSample:Show();
		sldFontColorOverhealR:Show();
		sldFontColorOverhealG:Show();
		sldFontColorOverhealB:Show();

		if c:GetCurrentProfile()[c.OPT_UIATTR_SHOWOVERHEAL] then
			lblFontColorOverheal:SetText("Font Color (overheal):");
			lblFontColorOverhealSample:SetText("(1112)");
			lblFontColorOverhealSample:SetXOffset(560);
		elseif c:GetCurrentProfile()[c.OPT_UIATTR_SHOWFULL] then
			lblFontColorOverheal:SetText("Font Color (full):");
			lblFontColorOverhealSample:SetText(q:GetText("full"));
			lblFontColorOverhealSample:SetXOffset(575);
		else
			lblFontColorOverheal:SetText("Font Color (+0):");
			lblFontColorOverhealSample:SetText(q:GetText("+0"));
			lblFontColorOverhealSample:SetXOffset(580);
		end
	else
		lblFontColorOverheal:Hide();
		lblFontColorOverhealSample:Hide();
		sldFontColorOverhealR:Hide();
		sldFontColorOverhealG:Hide();
		sldFontColorOverhealB:Hide();
	end
end

function c:SldFontSize_ValueChanged(self)
	if c.initFinished then
		c:GetCurrentProfile()[c.OPT_UIATTR_FONTSIZE] = self:GetValue();
		lblFontSize:SetText(q:GetText("Font Size: %s px", c:GetCurrentProfile()[c.OPT_UIATTR_FONTSIZE]));
	end
end

function c:SldFontSizeCritical_ValueChanged(self)
	if c.initFinished then
		c:GetCurrentProfile()[c.OPT_UIATTR_FONTSIZE_CRITICAL] = self:GetValue();
		lblFontSizeCritical:SetText(q:GetText("Font Size (critical): %s px", c:GetCurrentProfile()[c.OPT_UIATTR_FONTSIZE_CRITICAL]));
	end
end

function c:SldXOffset_ValueChanged(self)
	if c.initFinished then
		c:GetCurrentProfile()[c.OPT_UIATTR_XOFFSET] = self:GetValue();
		lblXOffset:SetText(q:GetText("X Offset: %s px", c:GetCurrentProfile()[c.OPT_UIATTR_XOFFSET]));
	end
end

function c:SldYOffset_ValueChanged(self)
	if c.initFinished then
		c:GetCurrentProfile()[c.OPT_UIATTR_YOFFSET] = self:GetValue();
		lblYOffset:SetText(q:GetText("Y Offset: %s px", c:GetCurrentProfile()[c.OPT_UIATTR_YOFFSET]));
	end
end

function c:SldColor_ValueChanged(self)
	if c.initFinished then
		c:GetCurrentProfile()[self.profile][self.col] = self:GetValue();
		if self.profile == c.OPT_UIATTR_FONTCOLOR then
			lblFontColorSample:SetTextColor(q:GetColorRBGA(c:GetCurrentProfile()[c.OPT_UIATTR_FONTCOLOR]));
		elseif self.profile == c.OPT_UIATTR_FONTCOLOR_CRITICAL then
			lblFontColorCriticalSample:SetTextColor(q:GetColorRBGA(c:GetCurrentProfile()[c.OPT_UIATTR_FONTCOLOR_CRITICAL]));
		elseif self.profile == c.OPT_UIATTR_FONTCOLOR_OVERHEAL then
			lblFontColorOverhealSample:SetTextColor(q:GetColorRBGA(c:GetCurrentProfile()[c.OPT_UIATTR_FONTCOLOR_OVERHEAL]));
		end
	end
end

function c:GetCurrentProfile()
	if c.initFinished then
		local profileKey = cbProfile.value[c.PROFILEKEY_KEY];
		local subProfileKey = cbSubProfile.value;
		local spellType = cbSpellType.value;
		local spellSource = cbSpellSource.value;

		if spellSource and chIsSpellTypeEnabled:GetChecked() then
			return QOL_OPTIONS[c.name][profileKey][subProfileKey][spellType][spellSource];
		elseif spellType and chIsSubProfileEnabled:GetChecked() then
			return QOL_OPTIONS[c.name][profileKey][subProfileKey][spellType];
		elseif subProfileKey and chIsProfileEnabled:GetChecked() then
			return QOL_OPTIONS[c.name][profileKey][subProfileKey];
		else
			return QOL_OPTIONS[c.name][profileKey];
		end
	end
end

function c:RevertSettingsChanges()
	QOL_OPTIONS[c.name] = c.optionsPanel.oldValues;
end

function c:SaveSettingsChanges()
	c.optionsPanel.oldValues = q:Deepcopy(QOL_OPTIONS[c.name]);
end